---
title: 02 GNOME
description: The GNOME Desktop Environment
published: true
date: 2023-04-30T01:23:34.912Z
tags: 
editor: markdown
dateCreated: 2023-04-28T07:54:54.911Z
---

# Getting back in with the installation USB
First we have to get back into the installation medium to install the network components and the Desktop Environment.

You just start from USB again, Check your network, Mount the needed drives and chroot into the system

You might think, Why did I make you go trough this trouble?

Well, This routine should be common knowledge for Arch users, If you ever break your system, you now know how to get back into it and hopefully fix your system.

So once again so you don't have to go back to the previous guide.

	ping archlinux.org

OK? Ctrl + C and mount the root partition (if encrypted run cryptroot open PARTITION cryptroot first and replace the directory with /dev/mapper/cryptroot

	mount /dev/nvme0n1p1 /mnt

Don't forget the boot partition

	mount /dev/nvme0n1p1 /mnt

And finally chroot into the system so you can change whatever you need to change

	arch-chroot /mnt

You should be root inside your installed system

# Installing GNOME
First we are going to install bare GNOME with networkmanager and a terminal, because we won't get anywhere without it :P

	pacman -S gnome-desktop gdm gnome-control-center gnome-keyring gnome-themes-extra networkmanager alacritty

just wait for everything to install, This can take a while depending on your network connection.

Now we need to enable the needed services for loading the Desktop Manager and Network connections

	systemctl enable gdm

	systemctl enable NetworkManager

# Reboot into Desktop Environment
Run the following command to escape from the chroot

	exit

Run the following command to restart

	reboot

Remove the USB when your screen turns black and it should boot into gdm, here you can enter your password and this should bring you into GNOME, Be sure to test your network connection.

If you use wifi, but you can't see the card, go back in with the USB again and install linux-firmware.

# Installing basic GNOME programs (Optional)
All of these are optional, and if you plan to use another program for it then don't install it, If you are unsure I would recommend installing them all.

Who doesn't need a calculator?

	pacman -S gnome-calculator

Do you want to browse files in a graphical environment?

	pacman -S nautilus

Want to see system usage, show or quit running applications?

	pacman -S gnome-system-monitor

Do you ever download .zip .rar or other archives?

	pacman -S file-roller

A nice and simple text editor?

	pacman -S gedit

Something to view images?

	pacman -S eog

something to view PDF files?

	pacman -S evince

Ever need to see your installed fonts or install new ones?

	pacman -S gnome-font-viewer

The default backgrounds?

	pacman -S gnome-backgrounds

How about a Calendar?

	pacman -S gnome-calendar

You have a top clock without this program, but it can be handy for world clocks, alarms, timers, etc.

	pacman -S gnome-clocks

Do you need something for opening and editing contacts?

	pacman -S gnome-contacts

A very detailed map of the world, powered by OpenStreetMaps

	pacman -S gnome-maps

Something to view the weather?

	pacman -S gnome-weather

# Installing a nice icon theme (Optional)
Clone the repository

	git clone https://aur.archlinux.org/numix-icon-theme-git.git

Now change the directory to the just downloaded folder

	cd numix-icon-theme-git

Now build and install the package

	makepkg -si

Give it your password when it asks you for it and answer yes to every question.

Clone the repository

	git clone https://aur.archlinux.org/numix-square-icon-theme.git

Now change the directory to the just downloaded folder

	cd numix-square-icon-theme

Now build and install the package

	makepkg -si

Give it your password when it asks you for it and answer yes to every question.

It will not change directly, We will do that in the next section.

Ofcourse you can install any icon theme you want, I just like this GPL icon theme.

# Gnome Extensions (Optional)
The Gnome desktop is missing some obvious functions by default. that's where extensions come in.

To enable gnome extensions being installed from their website you need to install a package.

Clone the repository

	git clone https://aur.archlinux.org/chrome-gnome-shell.git

Now change the directory to the just downloaded folder

	cd chrome-gnome-shell

Now build and install the package

	makepkg -si

Give it your password when it asks you for it and answer yes to every question.

Now open Firefox and go to https://addons.mozilla.org/en-US/firefox/addon/gnome-shell-integration/

Click on Add to Firefox, Then click Add on the popup that shows after the download.

Now you can go to https://extensions.gnome.org/ and easily install any extension

Just toggle the Off button to On and press Install when you get the prompt.

Here are a few I really recommend

#### Pacman Updates Indicator
This one is just a must have for Arch with Gnome, Just install it
https://extensions.gnome.org/extension/1010/archlinux-updates-indicator/

You will need run the following command for it to work properly

	sudo pacman -S pacman-contrib

If you installed the GUI for pacman be sure to click it after installation then go to settings and change the commands for updating packages to pamac-manager --updates and the one for opening the package manager to pamac-manager

#### AppIndicator Support
This extension adds tray icons to your top bar, It is a must if you use any application that uses tray icons.
https://extensions.gnome.org/extension/615/appindicator-support/

#### System Monitor
This extension will give you real time detailed information about your system in the top bar. my preferred settings are, Disable the Icon and Enable Display in the Middle. Then go trough each of the tabs, Disable Show Text for all, Hide Memory, Enable CPU, Net, Disk, GPU, Thermal and Fan, Display them all as graph except for the latter 2 make them text and be sure you select the right sensor.
https://extensions.gnome.org/extension/120/system-monitor/

You will need to run the following command for it to work properly

	sudo sensors-detect

#### OpenWeather
This extension adds the current weather to your top bar with a forecast if you click on it. I think it is a nice extra.
https://extensions.gnome.org/extension/750/openweather/

#### Mpris Indicator Button
This extension will put your media player in the top bar, You can go to the next song by scrolling on the icon
https://extensions.gnome.org/extension/1379/mpris-indicator-button/

#### Clipboard Indicator
This extension will remember your copy history, I can not live without it
https://extensions.gnome.org/extension/779/clipboard-indicator/

#### Desktop From Overview
This Extension will enable you to click anywhere but on a window in the overview to minimize all windows at once.
https://extensions.gnome.org/extension/1499/show-desktop-from-overview/

#### Sound Input/Output Device Chooser
This extension enables you to switch audio in and outputs quickly within 2 clicks.
https://extensions.gnome.org/extension/906/sound-output-device-chooser/

#### Launch New Instance
This extension will always launch a new instance if you open a program through clicking on it in the menu or your favorites, It is very handy if you use multiple windows of the same application
https://extensions.gnome.org/extension/600/launch-new-instance/

You can install any more you like, Some might not work due to a version mismatch, but there are plenty available, Try not to overdo it, It can slow down your system.

# Tweaking the DE (Optional)
## Gnome Settings
First we are going to look at the default gnome settings, Click the power button in the top right corner and then press the gear in the menu that appears.

#### Network

Under Network you can add your VPN if you use one of those.

#### WiFi
If you use Wifi connect to the network of your choice,

#### Bluetooth
If you have bluetooth you first need to run the following command

	sudo systemctl enable bluetooth

You can now go ahead and add any bluetooth devices you use,

#### Appearrance
Here you can set the theme to dark.

#### Notifications
Under Notifications, Turn of Popups, and turn of Lock Screen Notifications

#### Search
Under search only select the programs you want to search in when you search in the overview (The thing you get into when hitting the Windows key) You can also change the order by dragging and dropping.

#### Online Accounts
Under Online accounts you can add your Nextcloud Account, I would not recommend using any of the other services

#### Privacy
Under Privacy you can adjust some settings, But the default is fine.

#### Sound
Under sound you can select the correct sound in and outputs

#### Power
Under Power you can set some settings, I personally set Blank screen to 10 minutes disable the rest and set the power button to do nothing, If you use a laptop you might want to use different settings.

#### Display
Under Display Set your preferred desktop resolution and the maximum available Refresh Rate, If you use Large resolutions you can scale all elements of the desktop. If you use any other resolution than the largest I recommend to copy your Gnome configuration to the GDM configuration to do that run the following command

	sudo cp .config/monitors.xml /var/lib/gdm/.config/

#### Mouse & Touchpad
you can set your mouse settings, If you use a mouse they are good already, If you use a touchpad disable natural scrolling and edge scrolling, Set the speed as high as you find comfortable and enable tap to click and two-finger scrolling. Now you can tap with 1 finger for a left click, 2 fingers for a right click and 3 fingers for a middle click, "swiping" with 2 fingers will let you scroll in all directions.

#### Keyboard 
Under Keyboard shortcuts set Toggle Full Screen Mode to Super + F (Windows Key) and any other keyboard shortcuts you want. You can also add custom ones.

#### Printers
Under Printers you can add printers if you have set those up.

#### Language
Under Language you can set the language you prefer, note that you first need to add them using the instructions in step 17

#### Date & Time
Click the unlock button to enter your password, turn on Automatic Date & Time and set your correct timezone, You can also set a 24/12H clock here.
  
## Gnome Tweak Tool
Tweak tool allows you to set a bunch settings so install it.

	sudo pacman -S gnome-tweaks

Now we are going to customize the Tweaks application, Open it, you can find it in your menu.

#### General
Heere you can disable Suspend when laptop lid is closed, This only applies if you have a laptop, I prefer to keep the system on if I close the lid, If I want it to shut down I will do that manually.

#### appearance
Select Adwaita-dark for Applications and set Icons to Numix-Square, Ofcourse you can download and set any theme you want.

#### Extensions
Here you can adjust the settings for the extensions you have installed, but we already did that, You can always adjust more if you like.

#### Fonts
Here you can change the fonts, I would not mess too much with this.

#### Startup Applications
Here you can add guake and nextcloud if you have them installed.

#### Top Bar
Just enable everything except for battery percentage if you don't have a battery.

#### Window Titlebars
Same thing applies here, Enable the 2 extra buttons, Minimize and Maximize.

The rest of the settings are fine by default.

# Next
You can stop here, But you can also continue with any of the other options, if you want to maximize your gaming performance or want to get into programming you can click on the next guides of your choice.

In any way you don't need to do the KDE guide now, You have GNOME as your Desktop Environment already, installing both is possible and you can easily switch but the guide expects you to only install one, so some things might collide if you follow both guides, like GDM and LDDM.
