---
title: 05 Basic Programs
description: 
published: true
date: 2023-05-03T01:59:56.725Z
tags: 
editor: markdown
dateCreated: 2023-04-30T01:47:35.968Z
---

# Programs

Ofcourse any of these are optional, just go trough the list and install whatever you want.

# Installing Nextcloud
If you don't use Nextcloud, Go buy a raspberry pi now, Or build a small server if you really want to get serious in self hosting. You can also sign up at one of the many Nextcloud providers. It is a free and open source Cloud storage and syncing tool, for all your files, contacts, passwords, bookmarks, you name it, It even syncs everything with your phone, Desktop, anything really, It has some amazing features.

To clarify, This installs the Nextcloud sync client, You will need a provider or your own Nextcloud installation on a server.

Install the Sync Client

	sudo pacman -S nextcloud-client

You set it up by signing in to your nextcloud account, I do not recommend using the default settings or fast setup, I would skip the automatic folder configuration and set sync manually and just link your pictures folder to your pictures folder, your documents folder to your documents folder, and whatever folder you may need, This prevents the uploading of all your files or pretty dumb file management.

If you use Nautilus the Gnome File Manager, be sure to install this too, it will enhance your nextcloud experience with Nautilus integration.

Install git

	sudo pacman -S git

Clone the repository

	git clone https://aur.archlinux.org/nautilus-nextcloud.git

Now change the directory to the just downloaded folder

	cd nautilus-nextcloud

Now build and install the package

	makepkg -si

Give it your password when it asks you for it and answer yes to every question.

# Install a Graphical User Interface for Pacman
Now we are going to install pamac, Which is a front end for pacman the default package manager in Arch.

be sure to install git if you have not done this already

	sudo pacman -S git

Clone the repository

	git clone https://aur.archlinux.org/libpamac-aur.git

Now change the directory to the just downloaded folder

	cd libpamac-aur

Now build and install the package

	makepkg -si

Give it your password when it asks you for it and answer yes to every question.

	git clone https://aur.archlinux.org/pamac-aur.git

Now change the directory to the just downloaded folder

	cd pamac-aur

Now build and install the package

	makepkg -si

Give it your password when it asks you for it and answer yes to every question.

Now we need to enable AUR support, The AUR is the Arch User Repository, Here Arch Users can upload pre compiled packages that are available for Linux but are not in the Arch repositories, Then others can just easily download it from there.

1. Launch pamac
2. go to the settings
3. click on the AUR tab
4. Enable AUR support
5. enable checking for updates from AUR.

You can now install any program you want from this "app store"

# Install and Configure the Browser
First we need to install Firefox with the following command, Open it after it is done.

	sudo pacman -S firefox

Welcome to Firefox, We can't set all settings in the application settings, we need to adjust the profile for that, You can create your own configuration over at https://ffprofile.com/.

Now we need to extract it, and put the contents of the folder in our firefox profile folder.

First create a new profile open firefox and go to about:profiles

Here click on create new profile, Click next, give it a name, Be sure to make it the default profile and click on Finish.

Now go to /home/USERNAME/.mozilla/firefox/RANDOMCHARACTERS.PROFILENAME

Close firefox, remove all contents in the folder and then copy the contents of the downloaded archive into the current folder So in the RANDOMCHARACTERS.PROFILENAME folder should be prefs.json and the other files and folders, Don't put the FirefoxProfile folder in it but the contents of that folder.

Start Firefox, wait a bit, close it and start it again, All extensions settings and configuration should be done :)

# Install instant Messaging clients
Surely there are a lot of chat services, And you probably need more than 1, In that case I would recommend using Rambox or Ferdium, They have the advantage of having all web based chat services in 1 program, From Whatsapp to Discord and from IRC to Riot.

The following steps will install Ferdium on your system

Clone the repository

	git clone https://aur.archlinux.org/ferdium-bin.git

Now change the directory to the just downloaded folder

	cd ferdium-bin

Now build and install the package

	makepkg -si

Give it your password when it asks you for it and answer yes to every question.

Now you can open Ferdium, go to the settings, Disable every setting under general, and enable every setting under Appearance. Now you can go to services and enable any chat service you need.

# Install Mumble
Mumble is an encrypted UDP voice chat service, you can host your own servers or use one of the many public ones to chat to your friends using the highest quality possible.

Install it with the following command

	sudo pacman -S mumble

If you need a good public server you can use mine on houtworm.im :)

# Install some handy fonts
If you want to see the unicode emoticons you need to install the emoticon pack.

	sudo pacman -S noto-fonts-emoji

# Install Transmission
If you ever download stuff, try to use Torrents where possible, you do need a Torrent Client for that and Transmission is a great one, you can install it with the following command

	sudo pacman -S transmission-gtk

now you can use Torrents instead of overloading your favorite distros by downloading distro images over HTTP :)

# Installing Virtualbox
Virtualbox is a Virtual Machine manager, You can run operating systems within your current operating system. This can be handy if you like to mess around with systems, want to learn more about Linux or you need proprietary software that doesn't run trough Wine.

Install it with the following command

	sudo pacman -S virtualbox

When you get asked a question go with the dkms option.

# Installing Geekbench
Geekbench is a very nice benchmarking toolkit for benchmarking your CPU and GPU, It runs on almost everything, So you can compare your PC against your Phone and your Server for example :)

	git clone https://aur.archlinux.org/geekbench.git

Now change the directory to the just downloaded folder

	cd geekbench

Now build and install the package

	makepkg -si

Now you should be able to benchmark your system by running the following commands, There are more beenchmarks available but these 2 are the important ones :)

CPU

	geekbench --cpu

GPU Vulkan

	geekbench --compute vulkan

# Install MPD
MPD is the Media Player Daemon, It is a media player as a service that needs an mpd client to steer it. It is great for a raspberry connected to your receiver for example. I use it on my PC with Ampache installed on my server controlling it.

	sudo pacman -S mpd && systemctl --user enable mpd

If you want media keys to work with MPD

	sudo pacman -S mpd-mpris

# Install Audacious
Audacious is a nice smalll music player that will play about every format

Install it with the following command

	sudo pacman -S audacious

# Install VLC
Same thing applies for VLC is is a great Video player that will play anything from anywhere

Install it with the following command

	sudo pacman -S vlc

# Install Sublime
Sublime is a Subsonic music player. If you have a server somewhere I would recommend installing it.

Simply search for sublime-music in pamac and you can install it easily :)

# Installing OBS
OBS Studio is the go to streaming software on all platforms, Surely not everyone streams, but it is also very handy to record your screen or from other devices.

Install it with the following command

	sudo pacman -S obs-studio

# Installing NoiseTorch
NoiseTorch is simply amazing noise cancellation software, There could be a circus a mariachi band and a sporting event in your living room, and even when you are talking on a low volume, people on the other side will hear nothing but your voice. Truly amazing.

We need to install it from the AUR, so go ahead and clone the repo

	git clone https://aur.archlinux.org/noisetorch.git

change the directory

	cd noisetorch

install the package

	makepkg -si

Now you can find NoiseTorch in your menu, just open it configure it and load it to use it, Unload it again to stop it.
