---
title: 09 Mumble
description: 
published: true
date: 2023-05-03T02:58:14.663Z
tags: 
editor: markdown
dateCreated: 2023-05-03T01:58:53.909Z
---


Install and Configure Mumble
Mumble is an encrypted voice chat service, It is pretty much amazing, and nothing comes close to it.

First we are going to create a network

sudo docker network create --subnet=172.34.0.0/16 mumble

now we are going to create a folder

mkdir -p ~/docker/mumble

now we need to create the docker compose file

nano ~/mumble/docker-compose.yml

Add in the following text

version: '3'

services:
  mumble:
    image: mumblevoip/mumble-server
    container_name: mumble
    restart: always
    volumes:
      - /data/mumble/:/data
    environment:
      - SUPERUSER_PASSWORD=CHANGE ME INTO SOMETHING
    ports:
      - 64738:64738
      - 64738:64738/udp
    networks:
      mumble:
        ipv4_address: 172.34.0.10

networks:
  mumble:
    external: true
    name: mumble
    ipam:
      config:
        - subnet: 172.34.0.0/24

Lets create a config file now

sudo nano /data/mumble/murmur.ini

Add in the following text and adjust it where needed

logfile=/data/murmur.log
welcometext="Welcome to my Mumble server"
bandwidth=144000
users=1000
timeout=30
registerName=Mumble Server Root
registerLocation=NL

Now we finally change the owner of the folder to let Murmur access it

sudo chown -R 1000:1000 /data/mumble

Let it run with the following command

sudo docker-compose -f ~/docker/mumble/docker-compose.yml up -d
